unit UPsysRead1;
{$H-}   //AnsiStrings off so I can read UCSD strings
{$A-}
{$Z2}   //Force delphi to store enumerated types as 2 bytes Default is Z1

interface

uses
  Windows, Messages, SysUtils,{ Variants, }Classes, Graphics, Controls, Forms,
  Dialogs, FileCtrl, StdCtrls, Grids, ExtCtrls, ComCtrls, Buttons, Menus;

type
  TPsysReadForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    btnShowDirBlocks: TButton;
    Label7: TLabel;
    Label8: TLabel;
    Button3: TButton;
    ListBox1: TListBox;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    RadioGroup1: TRadioGroup;
    Panelx: TPanel;
    Panel2: TPanel;
    btnSaveTextFile: TButton;
    SaveDialog1: TSaveDialog;
    DebugMemo: TMemo;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Mountapsystemdiscimage1: TMenuItem;
    eXit1: TMenuItem;
    Viewselectedpsystemfile1: TMenuItem;
    Showdirectoryblocks1: TMenuItem;
    About1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Cleandir1: TMenuItem;
    Internalsizes1: TMenuItem;
    ShowDirectorysize1: TMenuItem;
    ShowFILEKINDside1: TMenuItem;
    WritecorrectedDIRtodisc1: TMenuItem;
    Directorystuff1: TMenuItem;
    Fixincorrectfiletypes1: TMenuItem;
    Savefixeddirectory1: TMenuItem;
    TabSheet5: TTabSheet;
    Memo4: TMemo;
    Viewdirectoryfixes1: TMenuItem;
    Button1: TButton;
    Checkdirectorystructureforreversedbytesex1: TMenuItem;
    Label1: TLabel;
    Writeoutbyteflippeddirectory1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnShowDirBlocksClick(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure StringGrid1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure btnSaveTextFileClick(Sender: TObject);
    procedure Mountapsystemdiscimage1Click(Sender: TObject);
    procedure eXit1Click(Sender: TObject);
    procedure Viewselectedpsystemfile1Click(Sender: TObject);
    procedure Showdirectoryblocks1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Cleandir1Click(Sender: TObject);
    procedure ShowDirectorysize1Click(Sender: TObject);
    procedure ShowFILEKINDside1Click(Sender: TObject);
    procedure WritecorrectedDIRtodisc1Click(Sender: TObject);
    procedure Savefixeddirectory1Click(Sender: TObject);
    procedure Fixincorrectfiletypes1Click(Sender: TObject);
    procedure Viewdirectoryfixes1Click(Sender: TObject);
    procedure Checkdirectorystructureforreversedbytesex1Click(
      Sender: TObject);
    procedure Writeoutbyteflippeddirectory1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PsysReadForm1: TPsysReadForm1;

implementation

uses AboutPsysReadU;

{$R *.dfm}

Const

  MAXDIR = 77;       (*MAX NUMBER OF ENTRIES IN A DIRECTORY*)
  VIDLENG = 7;       (*NUMBER OF CHARS IN A VOLUME ID*)
  TIDLENG = 15;      (*NUMBER OF CHARS IN TITLE ID*)
  FBLKSIZE = 512;    (*STANDARD DISK BLOCK LENGTH*)

type
  UCSDDATEREC = PACKED RECORD  (* occupies 2 bytes in UCSD, 3 in turbo!! *)
            MONTH: 0..12;      (*0 IMPLIES DATE NOT MEANINGFUL*)
            DAY: 0..31;        (*DAY OF MONTH*)
            YEAR: 0..100       (*100 IS TEMP DISK FLAG*) {can be 0..127}
            END (*DATEREC*) ;




  TBlock = packed array[0..511] of byte;
  TBlockfile = file of TBlock;

  sectbuffer = TBlock;  { For direct reading }
  pagebuffer = Packed array[0..1023] of byte; { For text files }
  short = string[40];

  VID = STRING[VIDLENG];
  (*DISK DIRECTORIES*)
  DIRRANGE = byte; //0..MAXDIR;
  TID = STRING[TIDLENG];
  FILEKIND = (UNTYPEDFILE,XDSKFILE,CODEFILE,TEXTFILE,
             INFOFILE,DATAFILE,GRAFFILE,FOTOFILE,SECUREDIR);
  daterec = SmallInt;

(*
    direntry = packed record
                        { This is the standard UCSD directory entry --
                          same for all implementations.  The first one
                          is aways the volume entry. }
        firstblok, lastblok : integer; { actually, lastblok -> beyond file }
        filtype, blank : byte;
        filname : string[15];
        fillast, { # of bytes in the last block -- need for file size }
        daterec : integer;
    end;  { takes up 26 bytes }

*)

{  ucsdDIRENTRY = RECORD
    DLASTBLK: SmallInt;   (*FIRST PHYSICAL DISK ADDR*)
    DFIRSTBLK: SmallInt;    (*POINTS AT BLOCK FOLLOWING*)

    CASE DFKIND: FILEKIND OF
      SECUREDIR,
      UNTYPEDFILE: (*ONLY IN DIR[0]...VOLUME INFO*)
                (DVID: VID;              (*NAME OF DISK VOLUME*)
                 DEOVBLK: SmallInt;       (*LASTBLK OF VOLUME*)
                 DNUMFILES: DIRRANGE;    (*NUM FILES IN DIR*)
                 DLOADTIME: SmallInt;     (*TIME OF LAST ACCESS*)
                 DLASTBOOT: DATEREC);    (*MOST RECENT DATE SETTING*)
      XDSKFILE,CODEFILE,TEXTFILE,INFOFILE,
      DATAFILE,GRAFFILE,FOTOFILE:
                (DTID: TID;              (*TITLE OF FILE*)
                 DLASTBYTE: 1..FBLKSIZE; (*NUM BYTES IN LAST BLOCK*)
                 DACCESS: DATEREC)       (*LAST MODIFICATION DATE*)
  END (*DIRENTRY*) ;

}
   (* Below is Laurie's attempt at a simpler variant record for direntry*)
(*
    direntry = packed record
                        { This is the standard UCSD directory entry --
                          same for all implementations.  The first one
                          is always the volume entry. }
        DFIRSTBLK, DLASTBLK : smallint; { actually, lastblok -> beyond file }
        case DFKIND:smallInt of
        0,8 :
        ({filtype, blank : byte;}
        DTID{filname} : string[15];
        DLASTBYTE{fillast}, { # of bytes in the last block -- need for file size }
        DACCESS{daterec} : smallint);
        1,2,3,4,5,6,7:
        ({xfiltype, xblank : byte;}
        DVID:string[7];
        DEOVBLK:SmallInt;
        DNUMFILES : 0..77;
        DLOADTIME : SmallInt;
        DLASTBOOT :Smallint);
    end;  { takes up 26 bytes }
*)

   (* Below is Laurie's Latest attempt at a simpler variant record for direntry*)
    direntry = packed record
                        { This is the standard UCSD directory entry --
                          same for all implementations.  The first one
                          is always the volume entry. }
        DFIRSTBLK, DLASTBLK : smallint; { actually, lastblok -> beyond file }
        case DFKIND: FILEKIND of
          SECUREDIR,
          UNTYPEDFILE:  {ONLY IN DIR[0]...VOLUME INFO}
                    (DVID:string[7];
                     DEOVBLK:SmallInt;
                     DNUMFILES : Smallint; //0..77; smallint so FlipWord works
                     DLOADTIME : SmallInt;
                     DLASTBOOT :Smallint);
          XDSKFILE,CODEFILE,TEXTFILE,INFOFILE,
          DATAFILE,GRAFFILE,FOTOFILE:
                    (DTID{filname} : string[15];
                     DLASTBYTE{fillast}, { # of bytes in the last block -- need for file size }
                     DACCESS{daterec} : smallint);
    end;  { takes up 26 bytes }


Const
  TempTransferName = 'TEMPTRANSFER.$$$';
Var
  inFilename:String;     //p-system image that has been mounted
  infile: file of tblock; {TBlockFile;} outfile : File;


    mainbuf : sectbuffer;
    textpage : pagebuffer;
    directory : record case boolean of
        true : (dir : array[0..77] of direntry);
        false: (bufs: array[0..3] of sectbuffer);
    end;
    SectorOffset : Integer;   {mostly 0 for .VOL files but 10 for .NSI image}
    //If we select a file then the following describes it
    SelectedFileName : String;
    SelectedFileIndex : SmallInt; //The index into directory.dir[x]

  DirectoryChanged : Integer;   //Incremented when DIR patched, cleared on load.
  ImageMounted : Boolean;       //false until p-system image loaded
  DirectoryHasBeenFlipped: Boolean;

Function HexBYTE(value:byte):String;  {Returns a string corresponding to a byte}
Var hexdigit : array [0..15] of char;
Begin
  hexdigit:='0123456789ABCDEF';
  HexByte:='  ';  //2 spaces
  HexByte[1] := hexdigit[value  div 16];
  HexByte[2] := hexdigit[value  mod 16];
End;

Function Hexword(value:Word):String; {Returns a string corresponding to a word}
Var Low,high : byte;
    hexdigit : array [0..15] of char;
Begin
  IF VALUE >=0 THEN
    BEGIN
  hexdigit:='0123456789ABCDEF';
  low := value mod 256;
  high := value div 256;
  HexWord:='    ';  //4 spaces
  hexWord[1] := hexdigit[high div 16];
  hexWord[2] := hexdigit[high mod 16];
  hexWord[3] := hexdigit[low  div 16];
  hexWord[4] := hexdigit[low  mod 16];
    END;
End;





Function UpString(s:string):String;
var i:integer;
Begin
  for i:= 1 to length(s) do
    s[i] := Upcase(s[i]);
  UpString :=s;
end;

Function ExtractUCSDDate(d:integer):String;
type  s3 = string[3]; tmonths = array[1..12] of s3;
const months : tmonths = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
var   month : 1..12; day,year:byte;
Begin
(*
  month := (d and $F000) shr 12;
  day   := (d and $0F80) shr 7;
  year  := (d and $007F);
  ExtractUCSDDate := IntToStr(day)+'-'+months[month]+'-'+IntToStr(year);

   From what I can see, the ucsd daterec is a 16 bit integer. Starting at
   bit 0 it packs the month into the lower 4 bits 0..3, the day into bits
   4 to 8 and the year into bits 9 to 15
   bit 15 to bit 0 ->     yyyyyyydddddmmmm     Laurie Boshell}
   so here is turbo code to unpack it!  *)

  month := (d and $000F);
  day   := (d and $01F0) shr 4;
  year  := (d and $FE00) shr 9;
  ExtractUCSDDate := IntToStr(day)+'-'+months[month]+'-'+IntToStr(year);
end;

Procedure FlipDir;
Begin
end;





{ ------------------ Print a directory entry --------------- }
procedure printentry(var de : direntry;k:integer);
var s,s1,s2,s3,s4,s5,s6,s7:string;
{ print the file name, the number of blocks, and the type }
{later I'll make it look more line a p-system dir with date etc LB}
var i:integer;
begin  { assume this is a live file -- test was made earlier }
  with de do begin
    s:=DTID{filname}; while length(s)<16 do s:=s+' ';
    s1:=IntToStr(DLASTBLK{lastblok} - DFIRSTBLK{firstblok});
    While length(s1)<4 do s1:=' '+s1;   //:3
    s2:=(ExtractUCSDDate(DACCESS{daterec}));
    While length(s2)<10 do s2:=' '+s2;
    s3:=IntToStr(DLASTBYTE{fillast});
    While length(s3) < 4 do s3:=' '+s3; //:3
    case byte(DFKIND) and $F{filtype} of
        0     : s4:='Utype';
        1     : s4:='Xdisk';
        2     : s4:='Code';
        3     : s4:='Text';
        4     : s4:='Info';
        5     : s4:='Data';
        6     : s4:='Graf';
        7     : s4:='Foto';
        8     : s4:='Secur';
        else s4:=IntToStr(byte(DFKIND)); //'????';
        end;
    While length(s4)< 5 do s4:=S4+' ';
    s5:= IntToStr(DFIRSTBLK{firstblok});
    While length(s5) < 5 do s5:=' '+s5;  //:4
    s6:= IntToStr(DLASTBLK{lastblok}-1);  //:4);
    While length(s6) < 5 do s6:=' '+s6;  //:4
    end;   {with de}
(*
  Form1.StringGrid1.Cells[0,k] := s;
  Form1.StringGrid1.Cells[1,k] := s1;
  Form1.StringGrid1.Cells[2,k] := s2;
  Form1.StringGrid1.Cells[3,k] := s3;
  Form1.StringGrid1.Cells[4,k] := s4;
  Form1.StringGrid1.Cells[5,k] := s5;
  Form1.StringGrid1.Cells[6,k] := s6;
*)
  PsysReadForm1.ListBox1.AddItem(s+s1+s2+s3+' '+s4+s5+s6,nil);


end;

{ this is for disc images }
function get1block(blockno : integer; var buffer : sectbuffer; off:integer) : integer;
var s:string;
Begin
 s:= 'block = '+IntToStr(blockno)+' offset ='+IntToStr(off);
 PsysReadForm1.DebugMemo.Lines.Add(s);
  seek(infile, blockno + off {SectorOffset});
  read(infile,buffer);
//  Blockread(infile,buffer,1{,result});
  Get1Block :=ioresult;
end;

function put1block(blockno : integer; var buffer : sectbuffer; off:integer) : integer;
Begin
(*  writeln('block = ',blockno,' seeking to byte =',loc); readln; *)
  seek(infile, blockno + off{SectorOffset});
  Write(infile,buffer);
//  Blockwrite(outfile,buffer,1{,result});
  put1Block :=ioresult;
end;


{ ----------- Read in the disk directory here -------------------- }
procedure readdir(off:integer);   {off is absolute sector offset. 10 for .NSI}
{ read the four blocks that make up the directory.  They are always
  at blocks 2,3,4,5 on the disk.   }
var count, result : integer;
begin
  for count := 0 to 3 do begin
    result := get1block(count+2, directory.bufs[count],off);
    if result <> 0 then begin
      ShowMessage('Sorry -- read error in getting directory.');
      halt;
      end;
    end;
end; { readdir }

procedure WriteOutdir(off:integer);   {off is absolute sector offset. 10 for .NSI}
{ write the four blocks that make up the directory.  They are always
  at blocks 2,3,4,5 on the disk.   }
var count, result : integer;
begin
  if DirectoryChanged = 0 then begin
    ShowMessage('There are no changes to save'); exit;
    end;
  for count := 0 to 3 do begin
    result := put1block(count+2, directory.bufs[count],off);
    if result <> 0 then begin
      ShowMessage('Sorry -- read error in writing directory.');
      halt;
      end;
    end;
  DirectoryChanged := 0;
  PsysreadForm1.Memo4.Lines.Add('Changes saved to disc image');
end; { Writeoutdir }

var
  has_been_flipped: boolean;

Procedure f_flipword(var arg:smallint);
type split = record case boolean of
               false : (i:smallint);
               true  : (b:packed array[0..1] of 0..255);
             end;
var a:split; temp :0..255;
Begin
  a.i := arg;
  temp := a.b[0]; a.b[0]:= a.b[1]; a.b[1] := temp;
  arg := a.i;
end;

procedure f_flipentry( i:integer; entry_0:boolean );
Begin
  with directory.dir[i] do
    begin
      f_flipword(dfirstblk);
      f_flipword(dlastblk);
      f_flipword(smallint(DFKIND));
      if i=0 {entry_0}
        then begin
               f_flipword(deovblk);
               f_flipword(dnumfiles);
               f_flipword(dloadtime);
               f_flipword(dlastboot);
//               f_flipword(filler1);
//               f_flipword(filler2);
             end
        else begin
               f_flipword(dlastbyte);
               f_flipword(daccess);
             end;
    end {with};
end {f_flipentry};

procedure f_flipdir;
var i,n:smallint;
begin
  with directory.dir[0] do
    begin
      n:=dnumfiles;
      f_flipword(n);
      f_flipentry( 0, true );
      if (n<0) or (n>maxdir) then n:=dnumfiles;
      if n<=maxdir then
        for i:=1 to maxdir {n} do f_flipentry( i, false );
    end {with};
end {f_flipdir};


function check_dir(var vname:shortstring):boolean;    {true if dir looks ok}
begin
  check_dir:=false;
  has_been_flipped := false; {assume that dir is same sex as this code}
  with directory.dir[0] do
    begin
      vname := directory.dir[0].dvid;
    //Ignore DFKIND in I.x as sometimes has crap in hi byte
      if (DFIRSTBLK=0) and (DLASTBLK in [6,10]) {single or duplicate dir}
        and (Length(directory.dir[0].dvid) in [1..7])
      then begin
        check_dir := true
      end
      else
        begin
          (*
          f_flipdir;    {flip incase already flipped}
          has_been_flipped := true;
          if (filekind in [0,8  {i.e.->[vol,secure}])
          and(dfirstblock=0)
          and(dlastblock in [6,10])  {single or duplicate dir}
          then begin
            vname := dfkind.dvid;
            check_dir := true
          end
          else check_dir := false;
          *)
        end;
  end; {with}
end;

function check_Duplicate_dir:boolean;    {true if looks like duplicate dir}
//Call after directory is known to be correct byte sex
begin
  check_duplicate_dir:= (directory.dir[0].DLASTBLK = 10);
end;




Procedure ShowTID;
var s:string;
Begin
  With directory.dir[0] do begin
    s:= infilename+' contains '+DVID+':  ['+IntToStr(DEOVBLK)+']';
    PSysReadForm1.Label7.Caption := s;
    s:=DVID+': '+IntToStr(DEOVBLK)+' blocks '+IntToStr(DNUMFILES AND 77)+' directory entries';
    PSysReadForm1.Label8.Caption := s;
  end; {with}
end;

Procedure SpitDir;
var k:integer; ch : char; count:integer;
  Procedure Topline;
  Begin //ClrScr;
    With directory.dir[0] do begin
      //Writeln(Path+infilename,' contains volume  ',VID,': of ',DEOVBLD,' blocks with ',DNUMFILES,' directory entries');
      //Writeln(VID,':');
      end; {with}
  end;

Begin
  TopLine;
  count:=0;
  ShowTID;
  PSYSReadForm1.ListBox1.Items.Clear;
  for k := 1 to 77 do begin
    {get out if all listed, stops last entry listed showing crap}
    if count >= directory.dir[0].DNUMFILES then begin
      exit;
      end;
      { Find out if this is a live file. }
    if length(directory.dir[k].DTID{filname}) in [1..15] then begin
      printentry(directory.dir[k],k);
      inc(count);
      end
    end;
end;




{$I-}
Procedure DoDir;
var io:integer;
Begin
  UpString(infilename);
  if infilename = '' then exit;
  assignFile(infile,infilename);
  reset(infile);   {make 'em 512 bytes long to match p-system sizes}
    {see what type of image as .NSI is offset by +10 sectors}
  io := IORESULT;
  if io <> 0 then begin
    ShowMessage('Could not open your file: '+infilename+' error='+IntToStr(io));
    exit;
    end;
  SectorOffset := 0;
  infilename := UpString(Infilename);
  if POS ('.NSI',infilename) > 0 then SectorOffset := 10;
  readdir(SectorOffset);
//  writeln('Finished reading the directory.');
  SpitDir;
end;
{$I+}


Procedure CorrectData2Code;
(* Some disc images have code files as data. Step through and correct this *)
Label 99;
var  x:shortint; count:integer; s:string;
Begin
  count:=0;   x:=1;
  PsysreadForm1.Memo4.Clear;
  while x<78 do begin {leave if all listed, stops last entry listed showing crap}
    if count >= directory.dir[0].DNUMFILES then goto 99; //exit;
   { Find out if this is a valid file entry. }
    if length(directory.dir[x].DTID{filname}) in [1..15] then begin
      s:= directory.dir[x].DTID{filname};
      if ord(directory.dir[x].DFKIND) <> ord(CODEFILE) then begin   //5= .DATA type
        if (s='SYSTEM.FILER')  or (s='SYSTEM.EDITOR')  or
           (s='SYSTEM.LINKER') or (s='SYSTEM.COMPILER')or
           (s='SYSTEM.FILER')  or (s='BASIC.COMPILER') or
           (s='SYSTEM.STARTUP') then begin
            directory.dir[x].DFKIND := CODEFILE;  // .CODE type
            Inc(DirectoryChanged);
            PsysreadForm1.Memo4.Lines.Add(s+' converted to codefile');
            end;
        end;  // if not CODEFILE
      if ord(directory.dir[x].DFKIND) <> ord(DATAFILE) then begin   //5= .DATA type
        if (s='SYSTEM.LIBRARY')or (s='SYSTEM.MISCINFO') or
           (s='SYSTEM.PASCAL') or (s='SYSTEM.INTERP')   or
           (s='SYSTEM.MICRO') then begin
            directory.dir[x].DFKIND := DATAFILE;  // .CODE type
            Inc(DirectoryChanged);
            PsysreadForm1.Memo4.Lines.Add(s+' converted to datafile');
            end;
        If (POS('OPCODE',s)>0) or (POS('ERRORS',s)>0) then begin
          directory.dir[x].DFKIND := DATAFILE;
          Inc(DirectoryChanged);
          PsysreadForm1.Memo4.Lines.Add(s+' converted to datafile');
          end;
        end;  // if not DATAFILE
      if ord(directory.dir[x].DFKIND) <> ord(CODEFILE) then begin   //2= CODEFILE
        If POS('.CODE',s) >0 then begin
          directory.dir[x].DFKIND := CODEFILE;
          Inc(DirectoryChanged);
          PsysreadForm1.Memo4.Lines.Add(s+' converted to datafile');
          end;
        end;  //if not CODEFILE
      if ord(directory.dir[x].DFKIND) <> ord(TEXTFILE) then begin
        If POS('.TEXT',s) >0 then begin
          directory.dir[x].DFKIND := TEXTFILE;
          Inc(DirectoryChanged);
          PsysreadForm1.Memo4.Lines.Add(s+' converted to textfile');
          end;
        end;  //if not TEXTFILE

      inc(count);
      end;
    inc(x);
    end;  //a valid file entry
99:
  ShowMessage(IntToStr(DirectoryChanged)+' corrections made to p-system directory');
  SpitDir;
end;






procedure TPsysReadForm1.Button1Click(Sender: TObject);
begin
  {$I-}
  CloseFile(infile);
  if IORESULT = 0 then;
  {$I+}
  SelectedFileName :='';  SelectedFileIndex := 0;
  Opendialog1.FileName := '*.VOL';
  If OpenDialog1.Execute then Begin
    infilename := Opendialog1.FileName;
    ListBox1.Clear;
    Memo2.Clear; btnSaveTextFile.Enabled := false;
    Memo1.Clear;
    Memo3.Clear;
    assignFile(infile,infilename);
    reset(infile);   {make 'em 512 bytes long to match p-system sizes}
    DoDir;
    SpeedButton1Click(Sender);   //Show raw dir code
    end;
end;

procedure TPsysReadForm1.FormCreate(Sender: TObject);
begin
  DirectoryChanged := 0;
  ImageMounted:=false;
  DirectoryHasBeenFlipped := false;
  with Application do
  begin
    //NormalizeTopMosts;
    MessageBox( 'This program works with volume images (.VOL)'+#13
               +'of versions I.3, I.5, II.x and IV.0 of the p-system.'+#13+#13
               +'Should work with version III images.'+#13
               +'It changes the byte-sex of IV volume images so that all versions can read them.'+#13
               +'(IV.x automatically undoes this)'+#13+#13+#13
               +'.VOL format = 512 byte contiguous blocks, DIR at block 2','PSYSREAD: PLEASE NOTE:');
    //RestoreTopMosts;
  end;
//  Label1.Caption := 'Size of FILEKIND is '+IntToStr(sizeof(FILEKIND)); //1
//  Label3.Caption := 'Size of DIRENTRY is '+IntToStr(sizeof(DIRENTRY)); //26
//  Label4.Caption := 'Size of UCSDDATEREC is '+IntToStr(sizeof(ucsdDATEREC)); //26
  end;

var
  DisplayAsHex: Boolean;

procedure TPsysReadForm1.btnShowDirBlocksClick(Sender: TObject);
Const DisplayOffset = 0;
var i,j:word; s:shortString;   c:char; BlockOffset : integer;
begin
  If SpeedButton1.Down then BlockOffset :=0
  else if SpeedButton2.Down then BlockOffset :=1
  else if SpeedButton3.Down then BlockOffset :=2
  else if SpeedButton4.Down then BlockOffset :=3;
  PageControl1.ActivePage := Tabsheet1;
  PSysREadForm1.Memo1.Clear;
//  Label6.Caption := 'Start = '+HexWord(DisplayOffset);
  for i:= 0 to 31 do begin  //was 15
    s:= HexWord(DisplayOffset+(i*16))+':';
    for J := 0 to 15 do begin
      if DisplayAsHex then
        s:=s+' '+Hexbyte(Directory.bufs[BlockOffset{0}][DisplayOffset+(i*16)+j])
      else begin  //DisplayAsAscii
        c:= char(Directory.bufs[BlockOffset{0}][DisplayOffset+(i*16)+j]);
        if not (c in [' '..'~']) then c:='.';
        s:=s+' '+' '+c;
        end;
      end;
    PSysReadForm1.Memo1.Lines.Add(s);
    end;
end;

{ ---------------  Process a file here --------------------------- }

Procedure Spit(b:byte);
Begin
  PSysREadForm1.Memo2.Lines.Add(char(b));
end;

procedure getfile(var entry : direntry);
var
  outfile : File of byte;
  newname : string[16];
  result, blockno, k : integer;
    { ------- Filter a page of a text file ---------- }
    procedure pageout(var p : pagebuffer);
    const  DLE = 16;  CR = 13;  ZERO = 0;  LF = 10;  BLANK = 32;
    var cursor, nblanks : integer; nextc, extra : byte;
    begin
      cursor := 0;
      while cursor <= 1023 do begin
        nextc := p[cursor];  cursor := cursor + 1;
        case nextc of
          CR : begin
                 Write(outfile,nextc);
                 extra := LF; Write(outfile,extra);
               end;
          ZERO : ; { don't write the zeroes that pad the page }
          DLE : begin { blank compression -- we expand it }
                  extra := BLANK;
                  nblanks := p[cursor] - 32; cursor := cursor + 1;
                  while nblanks > 0 do begin
                    Write(outfile,extra);
                    nblanks := nblanks - 1;
                    end;
                  end;
            else Write(outfile,nextc);
          end;
        end;
    end; { pageout }


begin { GETFILE here }
    newname:=TempTransferName;
    assign(outfile,newname);
    {$I-} rewrite(outfile); {$I+}
    result := ioresult;
    if result <> 0 then begin
        ShowMessage('Sorry -- cannot create the new file '+newname);
        halt;
    end;

    with entry do  { use the entry to get the file }
    if (ord(DFKIND)=3{text}) or (ord(DFKIND)=-32765 {text}) then begin
(*      writeln('Reading starts at ',firstblok + 2,' and goes for ',
            lastblok - firstblok - 2,' blocks.');
      writeln('Number of bytes in last block is :',fillast);
*)
      blockno := DFIRSTBLK{firstblok} + 2;
      while blockno <= DLASTBLK{lastblok} - 1 do begin
        result := get1block(blockno,mainbuf,sectoroffset);
        if result <> 0 then begin
          ShowMessage('Sorry -- error reading the file.');
          halt;
          end;
        move(mainbuf,textpage,512);
        result := get1block(blockno + 1,mainbuf,sectoroffset);
        if result <> 0 then begin
          ShowMessage('Sorry -- error reading the file.');
          halt;
          end;
        move(mainbuf,textpage[512],512);
        blockno := blockno + 2;
        pageout(textpage);
        end;

    end else begin { not a text file }

    (*
      writeln('Reading starts at ',firstblok,' and goes for ',
            lastblok - firstblok,' blocks.');
      writeln('Number of bytes in last block is :',fillast);
    *)
      for blockno := DFIRSTBLK{firstblok} to DLASTBLK{lastblok} - 1 do begin

        result := get1block(blockno,mainbuf,sectoroffset);
(*
        if result <> 0 then begin
          writeln('Sorry -- error reading the file.');
          halt;
          end;
*)
        if blockno < DLASTBLK{lastblok} - 1 then
          for k := 0 to 511 do write(outfile,mainbuf[k])
        else
          for k := 0 to DLASTBYTE{fillast}-1 do write(outfile,mainbuf[k]);
          {do fillast-1 as fillast can be 512, sectorbuf is array[0..511]}
        end;  { for blockno }
    end;  { if text file }
    close(outfile);
end; { getfile }



procedure TPsysReadForm1.RadioGroup1Click(Sender: TObject);
begin
  DisplayAsHex := RadioGroup1.ItemIndex=1;
  btnShowDirBlocksClick(Sender);
end;

procedure TPsysReadForm1.StringGrid1Click(Sender: TObject);
begin
//  Label8.Caption := StringGrid1.Cells[0,StringGrid1.Row]+ ' line '+IntToStr(StringGrid1.Row);
//  SelectedFileName := StringGrid1.Cells[0,StringGrid1.Row];
//  SelectedFileIndex := StringGrid1.Row; //The index into directory.dir[x]
end;

procedure TPsysReadForm1.Button3Click(Sender: TObject);
var entry:direntry; f:file of byte; i:integer; b:byte; s,s1:string; c:char;
begin
  if SelectedFileIndex > 0 then begin
    Memo2.Clear; Panel2.Caption :='';btnSaveTextFile.Enabled := false;
    entry := Directory.dir[SelectedFileIndex];
    GetFile(entry);
    with entry do if ((ord(DFKIND) and $F) = 3{text}) or (ord(DFKIND)= -32765{flipped}) then begin
      PageControl1.ActivePage := TabSheet2;
      Memo2.Lines.LoadFromFile (TempTransferName);
      Panel2.Caption := '   File is :    '+entry.DTID;
      btnSaveTextFile.Enabled := true;
      end
    else begin  //non text file
      PageControl1.ActivePage := TabSheet3;
      Memo3.Clear;
      try
      AssignFile(f,TempTransferName);
      Reset(f);
      i:=0; s:=''; s1:='';
      while not eof(f) do begin
        seek(f,i); read(f,b);
        if s='' then s:=HexWord(i)+':';
        s:= s+' '+HexByte(b);
        c:= char(b); if not (c in [' '..'~']) then c:='.';
        s1:=s1+' '+c;
        if (i+1) mod 16 = 0 then begin
          Memo3.Lines.Append(s+s1);
          s:=''; s1:='';
          end;
        inc(i);
        end;  //while not EOF
      if s<>'' then begin    //show tail end if not complete line/block
        While length(s) < 54 do s:=s+' ';
        Memo3.Lines.Append(s+s1);
        end;
      finally
      CloseFile(f);
      end; //finally
      end;
    end;
end;


procedure TPsysReadForm1.ListBox1Click(Sender: TObject);
begin
(*
  Label8.Caption:= IntToStr(ListBox1.ItemIndex)+' '+
                   ListBox1.Items.Strings[ListBox1.ItemIndex];
*)
  SelectedFileName := ListBox1.Items.Strings[ListBox1.ItemIndex];
  SelectedFileIndex := ListBox1.ItemIndex+1;  //The index into directory.dir[x]
end;

procedure TPsysReadForm1.ListBox1DblClick(Sender: TObject);
begin
  Button3Click(sender);
end;

procedure TPsysReadForm1.SpeedButton1Click(Sender: TObject);
begin
  btnShowDirBlocksClick(Sender);
end;

procedure TPsysReadForm1.SpeedButton2Click(Sender: TObject);
begin
  btnShowDirBlocksClick(Sender);
end;

procedure TPsysReadForm1.SpeedButton3Click(Sender: TObject);
begin
  btnShowDirBlocksClick(Sender);
end;

procedure TPsysReadForm1.SpeedButton4Click(Sender: TObject);
begin
  btnShowDirBlocksClick(Sender);
end;

procedure TPsysReadForm1.btnSaveTextFileClick(Sender: TObject);
begin
   If SaveDialog1.Execute then
     Memo2.Lines.SaveToFile(SaveDialog1.Filename);
end;

procedure TPsysReadForm1.Mountapsystemdiscimage1Click(Sender: TObject);
var s:shortString;
begin
   {$I-}
  CloseFile(infile);
  if IORESULT = 0 then;
  {$I+}
  SelectedFileName :='';  SelectedFileIndex := 0;
  Opendialog1.FileName := '*.VOL';
  If OpenDialog1.Execute then Begin
    infilename := Opendialog1.FileName;
    ListBox1.Clear;
    Memo2.Clear; btnSaveTextFile.Enabled := false;
    Memo1.Clear;
    Memo3.Clear;
    assignFile(infile,infilename);
    reset(infile);   {make 'em 512 bytes long to match p-system sizes}
    DoDir;
    SpeedButton1Click(Sender);   //Show raw dir code
    DirectoryChanged := 0;
    DirectoryHasBeenflipped := false;
    ImageMounted := true;
    Memo4.Lines.Clear;
    //check here for byte flipped directories

    If not Check_dir(s) then begin
      MessageBeep(MB_ICONEXCLAMATION);
      s:= 'THIS LOOKS LIKE A BYTE FLIPPED DIRECTORY - probably done by version IV.x'+#10#10+
      'This program can flip the byte sex to make it accessable to you'+#10+
      'Please select OK to flip the byte sex before proceeding';
      if MessageDlg(s,mtWarning,[mbOK, mbCANCEL],0) = mrOK then begin
        f_flipdir;
        DirectoryHasBeenFlipped := true;        
        SpitDir;
        end;
      end;
    Case check_duplicate_dir of
      true : PSYSREADForm1.Label1.Caption := 'Duplicate directory found';
      false: PSYSREADForm1.Label1.Caption := 'No duplicate directory';
      end;  //case
    end;  //if OpendialogExecute
end;

procedure TPsysReadForm1.eXit1Click(Sender: TObject);
begin
  Close;
end;

procedure TPsysReadForm1.Viewselectedpsystemfile1Click(Sender: TObject);
begin
  Button3Click(Sender);
end;

procedure TPsysReadForm1.Showdirectoryblocks1Click(Sender: TObject);
begin
  btnShowDirBlocksClick(Sender);
end;

procedure TPsysReadForm1.About1Click(Sender: TObject);
begin
  AboutBoxPSYSRead.ShowModal;
end;

procedure TPsysReadForm1.Cleandir1Click(Sender: TObject);
begin
  CorrectData2Code;
end;

procedure TPsysReadForm1.ShowDirectorysize1Click(Sender: TObject);
begin
  ShowMessage('Size of DIRENTRY is '+IntToStr(Sizeof(DIRENTRY))+' UCSD size is 26 bytes');
end;

procedure TPsysReadForm1.ShowFILEKINDside1Click(Sender: TObject);
begin
   ShowMessage('Size of FILEKIND is '+IntToStr(Sizeof(FILEKIND))+' UCSD size is 2 bytes');
end;

procedure TPsysReadForm1.WritecorrectedDIRtodisc1Click(Sender: TObject);
begin
  WriteoutDir(SectorOffset);
end;

procedure TPsysReadForm1.Savefixeddirectory1Click(Sender: TObject);
begin
  WriteoutDir(SectorOffset);
end;

procedure TPsysReadForm1.Fixincorrectfiletypes1Click(Sender: TObject);
begin
  CorrectData2Code;
end;

procedure TPsysReadForm1.Viewdirectoryfixes1Click(Sender: TObject);
begin
  PageControl1.ActivePage := TabSheet5;
end;

procedure TPsysReadForm1.Checkdirectorystructureforreversedbytesex1Click(
  Sender: TObject);
var s:shortstring;  
begin
    If not Check_dir(s) then begin
      MessageBeep(MB_ICONEXCLAMATION);
      s:= 'THIS LOOKS LIKE A BYTE FLIPPED DIRECTORY - probably done by version IV.x'+#10#10+
      'This program can flip the byte sex to make it accessable to you'+#10+
      'Please select OK to flip the byte sex before proceeding';
      if MessageDlg(s,mtWarning,[mbOK, mbCANCEL],0) = mrOK then begin
        f_flipdir;
        DirectoryHasBeenFlipped := true;
        SpitDir;
        end;
      end
      else ShowMessage('DIRECTORY '+s+' is NOT flipped');
end;

procedure TPsysReadForm1.Writeoutbyteflippeddirectory1Click(
  Sender: TObject);
begin
  if not DirectoryHasBeenFlipped then exit;
  Inc(DirectoryChanged);  //kludge to force directory write.
  WriteoutDir(SectorOffset);
end;

end.
